<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::equalizer::EqualizerLinearBandMapper Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1equalizer.html">equalizer</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_linear_band_mapper.html">EqualizerLinearBandMapper</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_linear_band_mapper-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::equalizer::EqualizerLinearBandMapper Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_equalizer_linear_band_mapper_8h_source.html">EqualizerLinearBandMapper.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::equalizer::EqualizerLinearBandMapper:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_linear_band_mapper__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1equalizer_1_1_equalizer_linear_band_mapper_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1equalizer_1_1_equalizer_linear_band_mapper_inherit__map" id="alexa_client_s_d_k_1_1equalizer_1_1_equalizer_linear_band_mapper_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_band_mapper_interface.html" title="alexaClientSDK::equalizer\l::EqualizerBandMapperInterface" alt="" coords="5,5,218,44"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::equalizer::EqualizerLinearBandMapper:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_linear_band_mapper__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1equalizer_1_1_equalizer_linear_band_mapper_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1equalizer_1_1_equalizer_linear_band_mapper_coll__map" id="alexa_client_s_d_k_1_1equalizer_1_1_equalizer_linear_band_mapper_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_band_mapper_interface.html" title="alexaClientSDK::equalizer\l::EqualizerBandMapperInterface" alt="" coords="5,5,218,44"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:af9fe583a7d341e59e366895a3feaf1e0"><td class="memItemLeft" align="right" valign="top">static std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_linear_band_mapper.html">EqualizerLinearBandMapper</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_linear_band_mapper.html#af9fe583a7d341e59e366895a3feaf1e0">create</a> (int numberOfTargetBands)</td></tr>
<tr class="separator:af9fe583a7d341e59e366895a3feaf1e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="member-group"></a>
EqualizerBandMapperInterface methods</h2></td></tr>
<tr class="memitem:aa676fc29a4f1039678a0d1e882c4bbea"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_linear_band_mapper.html#aa676fc29a4f1039678a0d1e882c4bbea">mapEqualizerBands</a> (const <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1audio.html#a9e92dbf094527d2bf8ead4429f0ef9ea">avsCommon::sdkInterfaces::audio::EqualizerBandLevelMap</a> &amp;bandLevelMap, std::function&lt; void(int, int)&gt; setBandCallback) override</td></tr>
<tr class="separator:aa676fc29a4f1039678a0d1e882c4bbea"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_band_mapper_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_band_mapper_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_band_mapper_interface.html">alexaClientSDK::equalizer::EqualizerBandMapperInterface</a></td></tr>
<tr class="memitem:a96c14a7aa041bd7efc1dd68be8263de2 inherit pub_methods_classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_band_mapper_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_band_mapper_interface.html#a96c14a7aa041bd7efc1dd68be8263de2">~EqualizerBandMapperInterface</a> ()=default</td></tr>
<tr class="separator:a96c14a7aa041bd7efc1dd68be8263de2 inherit pub_methods_classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_band_mapper_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">Provides linear mapping from AVS provided bands to target number of bands. Target bands are assumed to be equally distributed among whole spectrum of equalization frequencies starting from basses to treble. I.e. if there are 10 target bands, band with index 0 would be the lowest frequency while band with index 9 will be the highest frequency. AVS bands are also assumed to be distributed equally among the whole spectrum. I.e. if TREBLE is the only one band provided, it will cover top third of target frequencies. All other bands will be assumed to have have equalization level equal to 0 dB, meaning no equalization. This value will be distributed among target bands for lower two thirds. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="af9fe583a7d341e59e366895a3feaf1e0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af9fe583a7d341e59e366895a3feaf1e0">&#9670;&nbsp;</a></span>create()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_linear_band_mapper.html">EqualizerLinearBandMapper</a> &gt; alexaClientSDK::equalizer::EqualizerLinearBandMapper::create </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>numberOfTargetBands</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Factory method that creates a linear band mapper given the number of target bands.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">numberOfTargetBands</td><td></td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd></dd></dl>

</div>
</div>
<a id="aa676fc29a4f1039678a0d1e882c4bbea"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa676fc29a4f1039678a0d1e882c4bbea">&#9670;&nbsp;</a></span>mapEqualizerBands()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::equalizer::EqualizerLinearBandMapper::mapEqualizerBands </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1audio.html#a9e92dbf094527d2bf8ead4429f0ef9ea">avsCommon::sdkInterfaces::audio::EqualizerBandLevelMap</a> &amp;&#160;</td>
          <td class="paramname"><em>bandLevelMap</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::function&lt; void(int, int)&gt;&#160;</td>
          <td class="paramname"><em>setBandCallback</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Maps AVS band levels to the target equalizer bands. Number of target bands and mapping method are implementation specific. All supported bands should be defined. It is up to the implementation to decide what levels to use for missing bands.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">bandLevelMap</td><td>Map of AVS bands and their levels. </td></tr>
    <tr><td class="paramname">setBandCallback</td><td>Callback receiving the target band index and the level to be applied. It is up to the user to set up implementation properly to be able to map index to the band. No particular order of indices is guaranteed. The signature of the callback is void callback(int bandIndex, int level); </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1equalizer_1_1_equalizer_band_mapper_interface.html#a483f68ab5454730bd115865987cd33a6">alexaClientSDK::equalizer::EqualizerBandMapperInterface</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/EqualizerImplementations/include/EqualizerImplementations/<a class="el" href="_equalizer_linear_band_mapper_8h_source.html">EqualizerLinearBandMapper.h</a></li>
<li>/workplace/avs-device-sdk/EqualizerImplementations/src/<a class="el" href="_equalizer_linear_band_mapper_8cpp.html">EqualizerLinearBandMapper.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
